de.esprit.appsuite.database.dbgui.field

## Class TimestampField

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.text.JTextComponent
        - - javax.swing.JTextField
          - - de.esprit.common.gui.ZTextField
            - - de.esprit.appsuite.database.dbgui.field.AbstractTextField<T>
              - - de.esprit.appsuite.database.dbgui.field.AbstractCharField<java.sql.Timestamp>
                - - de.esprit.appsuite.database.dbgui.field.TimestampField

- All Implemented Interfaces:
    Field<java.sql.Timestamp>, Modifieable, Clearable, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, javax.accessibility.Accessible, javax.swing.Scrollable, javax.swing.SwingConstants

      public class TimestampField
      extends AbstractCharField<java.sql.Timestamp>

  This field provides a means for timestamp input. It's value is a `Timestamp` object. It manages the Timestamp-String conversions internally.
  Note that the field has been sharpened for the hot key CTRL-. which automatically inserts the current timestamp value in the predefined format.
  Author:
    Rainer Buesch
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JTextField

      `javax.swing.JTextField.AccessibleJTextField`

    - ### Nested classes/interfaces inherited from class javax.swing.text.JTextComponent

      `javax.swing.text.JTextComponent.AccessibleJTextComponent, javax.swing.text.JTextComponent.DropLocation, javax.swing.text.JTextComponent.KeyBinding`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JTextField

      `notifyAction`

    - ### Fields inherited from class javax.swing.text.JTextComponent

      `DEFAULT_KEYMAP, FOCUS_ACCELERATOR_KEY`

    - ### Fields inherited from class javax.swing.JComponent

      `accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface javax.swing.SwingConstants

      `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TimestampField(NlsDatabaseKey nls)`
    `TimestampField(NlsDatabaseKey nls, boolean isNotNull)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected FieldDocModel` | `createDefaultModel()`
    `java.sql.Timestamp` | `createValue()` Not actually used
    `protected java.text.DateFormat` | `getFormat()`
    `java.lang.String` | `getStringValue()` Must use the toString(Object) implementation of subclasses
    `java.sql.Timestamp` | `getValue()` Returns the field value as an Object - or null if the field is empty.
    `boolean` | `inputEquals(boolean b)` Tests if the field input is equal to the given boolean value.
    `boolean` | `inputEquals(double d)` Tests if the field input is equal to the given double number.
    `boolean` | `inputEquals(int i)` Tests if the field input is equal to the given int number.
    `boolean` | `inputEquals(java.lang.Object obj)` Tests if the field input is equal to the given object.
    `void` | `setInsertDefaultValue()` Requests the field to search for insert-default values in the 'insert_defaults' database table.
    `void` | `setTimestampFormat(java.text.SimpleDateFormat format)` Allows for setting the timestamp format explicitly.
    `void` | `setTimestampFormat(java.lang.String formatStr)` Allows for setting the timestamp format explicitly.
    `void` | `setValue(java.util.Date value)`
    `void` | `setValue(java.lang.String valueStr)`
    `void` | `setValue(java.sql.Timestamp value)` Sets the field value to the given object.
    `java.lang.String` | `toString(java.lang.Object ts)` Converts the object to a String according to the policy of the affected field component.
    `java.sql.Timestamp` | `toValue(java.lang.Object o)` Tries to convert any object value to the target data type of this field.

    - ### Methods inherited from class de.esprit.appsuite.database.dbgui.field.AbstractCharField

      `setDocument`

    - ### Methods inherited from class de.esprit.appsuite.database.dbgui.field.AbstractTextField

      `getDefaultBackground, getJLabel, getLabel, getName, getNlsKey, getUnitComponent, getWidget, isLocked, isNotNull, isPrimaryKey, isRecordTypeField, isStretchableX, isStretchableY, setCheckedWidth, setColumns, setFieldText, setLocked, setModified, setModifyFlag, setNotNull, setNumericInputOnly, setPrimaryKey, setRecordTypeField, setStretchableX, setStretchableY, setText, setUnitComponent, setUnitString, setValue, setWidthChecked, toString`

    - ### Methods inherited from class de.esprit.common.gui.ZTextField

      `addDocumentListener, clear, fireActionPerformed, isEmpty, isRequestFocusEnabled, removeDocumentListener, setDropEnabled, setMinimumColumns, setToolTipText`

    - ### Methods inherited from class javax.swing.JTextField

      `actionPropertyChanged, addActionListener, configurePropertiesFromAction, createActionPropertyChangeListener, getAccessibleContext, getAction, getActionListeners, getActions, getColumns, getColumnWidth, getHorizontalAlignment, getHorizontalVisibility, getPreferredSize, getScrollOffset, getUIClassID, isValidateRoot, paramString, postActionEvent, removeActionListener, scrollRectToVisible, setAction, setActionCommand, setFont, setHorizontalAlignment, setScrollOffset`

    - ### Methods inherited from class javax.swing.text.JTextComponent

      `addCaretListener, addInputMethodListener, addKeymap, copy, cut, fireCaretUpdate, getCaret, getCaretColor, getCaretListeners, getCaretPosition, getDisabledTextColor, getDocument, getDragEnabled, getDropLocation, getDropMode, getFocusAccelerator, getHighlighter, getInputMethodRequests, getKeymap, getKeymap, getMargin, getNavigationFilter, getPreferredScrollableViewportSize, getPrintable, getScrollableBlockIncrement, getScrollableTracksViewportHeight, getScrollableTracksViewportWidth, getScrollableUnitIncrement, getSelectedText, getSelectedTextColor, getSelectionColor, getSelectionEnd, getSelectionStart, getText, getText, getToolTipText, getUI, isEditable, loadKeymap, modelToView, moveCaretPosition, paste, print, print, print, processInputMethodEvent, read, removeCaretListener, removeKeymap, removeNotify, replaceSelection, restoreComposedText, saveComposedText, select, selectAll, setCaret, setCaretColor, setCaretPosition, setComponentOrientation, setDisabledTextColor, setDragEnabled, setDropMode, setEditable, setFocusAccelerator, setHighlighter, setKeymap, setMargin, setNavigationFilter, setSelectedTextColor, setSelectionColor, setSelectionEnd, setSelectionStart, setUI, updateUI, viewToModel, write`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface de.esprit.appsuite.database.dbgui.field.Field

      `isEmpty`

    - ### Methods inherited from interface de.esprit.common.type.Clearable

      `clear`

- - ### Constructor Detail

    - #### TimestampField

          public TimestampField(NlsDatabaseKey nls,
                        boolean isNotNull)

    - #### TimestampField

          public TimestampField(NlsDatabaseKey nls)

  - ### Method Detail

    - #### createDefaultModel

          protected FieldDocModel createDefaultModel()

      Overrides:
        `createDefaultModel` in class `AbstractCharField<java.sql.Timestamp>`

    - #### getFormat

          protected java.text.DateFormat getFormat()

    - #### setTimestampFormat

          public void setTimestampFormat(java.lang.String formatStr)

      Allows for setting the timestamp format explicitly. The field length is automatically adapted to the pattern of the timestamp format.

    - #### setTimestampFormat

          public void setTimestampFormat(java.text.SimpleDateFormat format)

      Allows for setting the timestamp format explicitly. The field length is automatically adapted to the pattern of the timestamp format.

    - #### createValue

          public java.sql.Timestamp createValue()
                                         throws InvalidFieldInputException

      Description copied from class: `AbstractTextField`
      Not actually used
      Specified by:
        `createValue` in interface `Field<java.sql.Timestamp>`
      Overrides:
        `createValue` in class `AbstractTextField<java.sql.Timestamp>`
      Throws:
        `InvalidFieldInputException` - If the input Object cannot be created due to a parsing error.

    - #### setValue

          public void setValue(java.sql.Timestamp value)

      Description copied from interface: `Field`
      Sets the field value to the given object. The implementation may be very different in different classes.
      Specified by:
        `setValue` in interface `Field<java.sql.Timestamp>`
      Overrides:
        `setValue` in class `AbstractTextField<java.sql.Timestamp>`

    - #### setValue

          public void setValue(java.util.Date value)

    - #### setValue

          public void setValue(java.lang.String valueStr)

    - #### getValue

          public java.sql.Timestamp getValue()

      Description copied from interface: `Field`
      Returns the field value as an Object - or null if the field is empty.
      Specified by:
        `getValue` in interface `Field<java.sql.Timestamp>`
      Overrides:
        `getValue` in class `AbstractTextField<java.sql.Timestamp>`

    - #### getStringValue

          public java.lang.String getStringValue()

      Description copied from class: `AbstractTextField`
      Must use the toString(Object) implementation of subclasses
      Specified by:
        `getStringValue` in interface `Field<java.sql.Timestamp>`
      Overrides:
        `getStringValue` in class `AbstractTextField<java.sql.Timestamp>`

    - #### toString

          public java.lang.String toString(java.lang.Object ts)

      Description copied from interface: `Field`
      Converts the object to a String according to the policy of the affected field component. This is important for DecimalField and DateField which eventually use localized strings. Note that this method must return an empty string if the object cannot be parsed.
      Specified by:
        `toString` in interface `Field<java.sql.Timestamp>`
      Overrides:
        `toString` in class `AbstractTextField<java.sql.Timestamp>`

    - #### inputEquals

          public boolean inputEquals(java.lang.Object obj)

      Description copied from interface: `Field`
      Tests if the field input is equal to the given object.
      Specified by:
        `inputEquals` in interface `Field<java.sql.Timestamp>`
      Overrides:
        `inputEquals` in class `AbstractTextField<java.sql.Timestamp>`

    - #### inputEquals

          public boolean inputEquals(int i)

      Description copied from interface: `Field`
      Tests if the field input is equal to the given int number.
      Specified by:
        `inputEquals` in interface `Field<java.sql.Timestamp>`
      Overrides:
        `inputEquals` in class `AbstractTextField<java.sql.Timestamp>`

    - #### inputEquals

          public boolean inputEquals(double d)

      Description copied from interface: `Field`
      Tests if the field input is equal to the given double number.
      Specified by:
        `inputEquals` in interface `Field<java.sql.Timestamp>`
      Overrides:
        `inputEquals` in class `AbstractTextField<java.sql.Timestamp>`

    - #### inputEquals

          public boolean inputEquals(boolean b)

      Description copied from interface: `Field`
      Tests if the field input is equal to the given boolean value.
      Specified by:
        `inputEquals` in interface `Field<java.sql.Timestamp>`
      Overrides:
        `inputEquals` in class `AbstractTextField<java.sql.Timestamp>`

    - #### setInsertDefaultValue

          public void setInsertDefaultValue()

      Description copied from interface: `Field`
      Requests the field to search for insert-default values in the 'insert_defaults' database table. The field uses its own name as a key for the lookup. If an insert-default value is found, it will be displayed as a default value in this field.

    - #### toValue

          public java.sql.Timestamp toValue(java.lang.Object o)

      Description copied from interface: `Field`
      Tries to convert any object value to the target data type of this field. An `IllegalArgumentException` is thrown when the type is not supported by the field.

Copyright © 2014 EsprIT-Systems. All Rights Reserved.